import { AnnotationLayer } from "./AnnotationLayer";
import { Series } from "./Series";
import { FinalValueSelectionMode } from "./FinalValueSelectionMode";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { Thickness } from "igniteui-angular-core/ES2015/Thickness";
import { FinalValueLayerFrame } from "./FinalValueLayerFrame";
import { Type } from "igniteui-angular-core/ES2015/type";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { AnnotationLayerView } from "./AnnotationLayerView";
/**
 * @hidden
 */
export declare class FinalValueLayer extends AnnotationLayer {
    static $t: Type;
    constructor();
    protected bf(): SeriesView;
    it(a: SeriesView): void;
    protected m2: FinalValueLayerView;
    m4: Series;
    m3: FinalValueSelectionMode;
    n4: Brush;
    n2: Brush;
    nd: number;
    n3: Brush;
    readonly n6: Thickness;
    m9: number;
    nb: number;
    na: number;
    m8: number;
    axisAnnotationFormatLabel: (item: any) => string;
    m5(): boolean;
    nc: number;
    protected mi(a: Series, b: boolean): void;
    protected mk(a: Frame, b: SeriesView): void;
    protected l5(a: Series): boolean;
    im(): void;
    private n5;
    private np;
    private m7;
    private m6;
    protected nq(a: FinalValueLayerFrame, b: boolean): void;
    protected mn(a: Frame, b: SeriesView): void;
    protected c8(): boolean;
    protected iy(a: any, b: string, c: any, d: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinalValueLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: FinalValueLayer);
    protected b1: FinalValueLayer;
    ap(): void;
    b2(a: Brush): Brush;
    ai(a: any): void;
}
