/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnnotationLayer } from "./AnnotationLayer";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { Base, Type, String_$type, typeCast, enumGetBox, fromEnum, runOn, delegateCombine, delegateRemove, Date_$type, Point_$type, markType } from "igniteui-angular-core/ES2015/type";
import { Series } from "./Series";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { Thickness } from "igniteui-angular-core/ES2015/Thickness";
import { CalloutCollisionMode_$type } from "./CalloutCollisionMode";
import { FontUtil } from "igniteui-angular-core/ES2015/FontUtil";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { CalloutLayerFrame } from "./CalloutLayerFrame";
import { HashSet$1 } from "igniteui-angular-core/ES2015/HashSet$1";
import { CalloutAnnotationWrapper } from "./CalloutAnnotationWrapper";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { LinkedList$1 } from "igniteui-angular-core/ES2015/LinkedList$1";
import { Dictionary$2 } from "igniteui-angular-core/ES2015/Dictionary$2";
import { LinkedListNode$1 } from "igniteui-angular-core/ES2015/LinkedListNode$1";
import { LabelCollisionManager } from "igniteui-angular-core/ES2015/LabelCollisionManager";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { CalloutAnnotation } from "./CalloutAnnotation";
import { IFastItemsSource_$type } from "igniteui-angular-core/ES2015/IFastItemsSource";
import { CalloutSeriesSelectingEventArgs } from "./CalloutSeriesSelectingEventArgs";
import { CalloutStyleUpdatingEventArgs } from "./CalloutStyleUpdatingEventArgs";
import { QuadTreeBoundingBox } from "igniteui-angular-core/ES2015/QuadTreeBoundingBox";
import { LabelCollisionInfo } from "igniteui-angular-core/ES2015/LabelCollisionInfo";
import { ScalerParams } from "./ScalerParams";
import { Size } from "igniteui-angular-core/ES2015/Size";
import { CalloutContentUpdatingEventArgs } from "./CalloutContentUpdatingEventArgs";
import { CalloutLabelUpdatingEventArgs } from "./CalloutLabelUpdatingEventArgs";
import { CalloutKey } from "./CalloutKey";
import { DataContext } from "igniteui-angular-core/ES2015/DataContext";
import { HashPool$2 } from "igniteui-angular-core/ES2015/HashPool$2";
import { PropertyMetadata } from "igniteui-angular-core/ES2015/PropertyMetadata";
import { isNaN_ } from "igniteui-angular-core/ES2015/number";
import { stringIsNullOrEmpty } from "igniteui-angular-core/ES2015/string";
import { FastItemObjectColumn } from "igniteui-angular-core/ES2015/FastItemObjectColumn";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { BrushUtil } from "igniteui-angular-core/ES2015/BrushUtil";
import { TextBlock } from "igniteui-angular-core/ES2015/TextBlock";
import { DOMExecutionContext } from "igniteui-angular-core/ES2015/DOMExecutionContext";
import { Color } from "igniteui-angular-core/ES2015/Color";
import { Line } from "igniteui-angular-core/ES2015/Line";
import { CalloutViewHelper } from "./CalloutViewHelper";
import { Rectangle } from "igniteui-angular-core/ES2015/Rectangle";
import { TranslateTransform } from "igniteui-angular-core/ES2015/TranslateTransform";
/**
 * @hidden
 */
export class CalloutLayer extends AnnotationLayer {
    constructor() {
        super();
        this.calloutStyleUpdating = null;
        this.nc = null;
        this.nd = null;
        this.ne = null;
        this.nb = null;
        this.na = null;
        this.n0 = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        this.n3 = new List$1(CalloutAnnotationWrapper.$, 0);
        this.n4 = new List$1(CalloutAnnotationWrapper.$, 0);
        this.m8 = null;
        this.n1 = new LinkedList$1(CalloutAnnotationWrapper.$);
        this.ny = new Dictionary$2(CalloutAnnotationWrapper.$, LinkedListNode$1.$.specialize(CalloutAnnotationWrapper.$), 0);
        this.nk = null;
        this.qt = new Rect(0, 0, 0, 1, 1);
        this.nq = false;
        this.oe = 0;
        this.qs = Rect.empty;
        this.np = false;
        this.calloutContentUpdating = null;
        this.calloutLabelUpdating = null;
        this.calloutSeriesSelecting = null;
        this.n2 = new List$1(SeriesPointOfInterest.$, 0);
        this.ns = false;
        this.nt = false;
        this.n6 = 0;
        this.nr = false;
        this.no = true;
        FastItemObjectColumn.m();
        this.l7 = true;
        let a = new CalloutLayerFrame();
        let b = new CalloutLayerFrame();
        let c = new CalloutLayerFrame();
        let d = this.fi / 1000;
        this.l1 = a;
        this.l0 = b;
        this.l2 = c;
        this.ab = CalloutLayer.$;
    }
    pl(a, b) {
        this.n4.clear();
        this.jc(false);
    }
    hy(a, b, c, d) {
        super.hy(a, b, c, d);
        let e = this.nz();
        switch (a) {
            case 3:
                this.px(b, e);
                break;
            case 1:
                for (let f = b; f < b + c; f++) {
                    let g = new CalloutAnnotation();
                    let h = new CalloutAnnotationWrapper();
                    h.b = g;
                    h.b.series = this.m7;
                    this.n4.insert(f, h);
                    this.px(f, e);
                }
                break;
            case 0:
                this.n4.v(b, c);
                break;
            case 2:
                for (let i = b; i < b + c; i++) {
                    this.px(i, e);
                }
                break;
            case 4:
                this.n4.clear();
                for (let j = 0; j < this.bz.count; j++) {
                    let k = new CalloutAnnotation();
                    let l = new CalloutAnnotationWrapper();
                    l.b = k;
                    l.b.series = this.m7;
                    this.n4.add(l);
                    this.px(j, e);
                }
                break;
        }
        this.jc(true);
    }
    da(a) {
        return false;
    }
    nz() {
        let a = new Dictionary$2(String_$type, Series.$, 0);
        if (this.bs != null) {
            for (let b = 0; b < this.bs.series.count; b++) {
                let c = this.bs.series._inner[b];
                if (c.name != null && !a.containsKey(c.name)) {
                    a.addItem(c.name, c);
                }
            }
        }
        return a;
    }
    px(a, b) {
        if (this.nj == null || this.nh == null) {
            return;
        }
        let c = a;
        if (this.ni != null) {
            c = this.ni.item(a);
        }
        let d = this.nj.item(a);
        let e = this.nh.item(a);
        let f = this.n4._inner[a];
        f.b.xValue = c;
        f.b.yValue = d;
        f.b.text = e != null ? e.toString() : "";
        if (this.ng != null) {
            f.b.key = this.ng.item(a);
        }
        if (this.nf != null) {
            f.b.content = this.nf.item(a);
        }
        else {
            f.b.content = this.bz.item(a);
        }
        if (this.calloutSeriesSelecting != null) {
            let g = ((() => {
                let $ret = new CalloutSeriesSelectingEventArgs();
                $ret.c = c;
                $ret.d = d;
                $ret.item = this.bz.item(a);
                return $ret;
            })());
            this.calloutSeriesSelecting(this, g);
            if (g.a != null) {
                f.b.series = g.a;
            }
            else if (g.e != null) {
                if (b.containsKey(g.e)) {
                    f.b.series = b.item(g.e);
                }
            }
        }
        this.py(f);
    }
    py(a) {
        let b = new Thickness(0, 3);
        if (isNaN_(this.qv.c) || isNaN_(this.qv.e) || isNaN_(this.qv.d) || isNaN_(this.qv.b)) {
            b = new Thickness(0, 3);
        }
        else {
            b = this.qv;
        }
        let c = this.qo != null ? this.qo : this.m4.ce(a.b.series);
        let d = this.qr != null ? this.qr : this.m4.ch();
        let e = this.qq != null ? this.qq : this.m4.cg();
        let f = this.qp != null ? this.qp : this.m4.cf(a.b.series);
        let g = isNaN_(this.oc) ? 0 : this.oc;
        if (this.nw && this.calloutStyleUpdating != null) {
            let h = new CalloutStyleUpdatingEventArgs();
            h.item = a.b.content;
            h.xValue = a.b.xValue;
            h.yValue = a.b.yValue;
            h.series = a.b.series;
            h.background = c;
            h.textColor = d;
            h.outline = e;
            h.leaderBrush = f;
            h.strokeThickness = g;
            this.calloutStyleUpdating(this, h);
            c = h.background;
            d = h.textColor;
            e = h.outline;
            f = h.leaderBrush;
            g = h.strokeThickness;
        }
        a.b.backgroundPadding = b;
        a.b.background = c;
        a.b.textColor = d;
        a.b.outline = e;
        a.b.leaderBrush = f;
        a.b.strokeThickness = g;
    }
    fs(a, b) {
        let c = this.gu(b);
        if (c == CalloutLayer.$$p[19]) {
            return this.ft(a, b, this.o9);
        }
        if (c == CalloutLayer.$$p[23]) {
            return this.ft(a, b, this.pg);
        }
        if (c == CalloutLayer.$$p[24]) {
            return this.ft(a, b, this.pj);
        }
        if (c == CalloutLayer.$$p[18]) {
            return this.ft(a, b, this.o6);
        }
        if (c == CalloutLayer.$$p[14]) {
            return this.ft(a, b, this.o0);
        }
        return super.fs(a, b);
    }
    get nh() {
        return this.nc;
    }
    set nh(a) {
        if (this.nc != a) {
            let b = this.nc;
            this.nc = a;
            this.raisePropertyChanged("LabelColumn", b, this.nc);
        }
    }
    get ni() {
        return this.nd;
    }
    set ni(a) {
        if (this.nd != a) {
            let b = this.nd;
            this.nd = a;
            this.raisePropertyChanged("XColumn", b, this.nd);
        }
    }
    get nj() {
        return this.ne;
    }
    set nj(a) {
        if (this.ne != a) {
            let b = this.ne;
            this.ne = a;
            this.raisePropertyChanged("YColumn", b, this.ne);
        }
    }
    get ng() {
        return this.nb;
    }
    set ng(a) {
        if (this.nb != a) {
            let b = this.nb;
            this.nb = a;
            this.raisePropertyChanged("KeyColumn", b, this.nb);
        }
    }
    get nf() {
        return this.na;
    }
    set nf(a) {
        if (this.na != a) {
            let b = this.na;
            this.na = a;
            this.raisePropertyChanged("ContentColumn", b, this.na);
        }
    }
    pn(a, b) {
        if (b.propertyName == CalloutAnnotation.$$p[13] || b.propertyName == CalloutAnnotation.$$p[14]) {
            let c = a.k;
            if (!this.n0.contains(c)) {
                this.n3.add(c);
                this.jc(false);
            }
        }
    }
    bf() {
        return new CalloutLayerView(this);
    }
    it(a) {
        super.it(a);
        this.m4 = a;
    }
    get qv() {
        return new Thickness(1, this.n8, this.oa, this.n9, this.n7);
    }
    get m9() {
        if (this.m8 == null) {
            this.m8 = FontUtil.toFontInfo(this.e4, this.pc);
        }
        return this.m8;
    }
    mi(a, b) {
        if (this.m7 == null || this.m7 == a) {
            if (!this.aq.c) {
                this.jc(b);
            }
        }
    }
    mk(a, b) {
        super.mk(a, b);
        let c = a;
        c.p.clear();
        c.q.clear();
        c.m.clear();
        c.f.clear();
        c.h.clear();
        c.g.clear();
        c.j.clear();
        c.l.clear();
        c.k.clear();
        c.i.clear();
        c.n.clear();
        c.o.clear();
        c.t.clear();
        c.u.clear();
        c.r.clear();
        c.s.clear();
        let d = this.n5();
        let e = new List$1(CalloutAnnotationWrapper.$, 0);
        if (this.nu) {
            if (this.l5(this.m7)) {
                this.pu(this.m7, c, e);
            }
            else {
                for (let f of fromEnum(this.bs.series)) {
                    if (this.l5(f)) {
                        this.pu(f, c, e);
                    }
                }
            }
        }
        this.pt(c, d, e);
    }
    js(a, b) {
        super.js(a, b);
        let c = b.width - this.qt.width;
        let d = b.height - this.qt.height;
        let e = 0;
        if (Math.abs(c) > Math.abs(d)) {
            e = c;
            this.n6 = c * this.lx.width;
        }
        else {
            e = d;
            this.n6 = d * this.lx.height;
        }
        if (e > 0 && this.n6 > 5) {
            this.nt = true;
        }
        if (e < 0 && this.n6 > 5) {
            this.ns = true;
        }
    }
    jr(a, b) {
        super.jr(a, b);
        if (!a.equals1(b)) {
            this.nr = true;
        }
    }
    get qu() {
        return this.qs;
    }
    set qu(a) {
        this.qs = a;
    }
    pt(a, b, c) {
        if (this.bs != null) {
            this.qt = this.bs.mq;
        }
        if (this.lx.isEmpty) {
            return;
        }
        this.qu = new Rect(0, this.lx.left, this.lx.top, this.lx.width, this.lx.height);
        if (this.nk != null && this.ox != null && this.ox != this.nk.ak) {
            this.pp();
        }
        if (this.nk == null) {
            let d = this.nl();
            if (d != null) {
                this.nk = d;
                let e = this.nk;
                e.labelsMoved = delegateCombine(e.labelsMoved, runOn(this, this.pm));
            }
            else {
                let f = this.lp(this.bi);
                this.nk = new LabelCollisionManager(this.lx.right, this.lx.bottom, this.lx, this.m4.b4(), this.ob, this.nm(), this.oi(), this.oh(), this.nv);
                if (this.ox != null) {
                    this.nk.ak = this.ox;
                    this.nk.ai = this;
                }
                let g = this.nk;
                g.labelsMoved = delegateCombine(g.labelsMoved, runOn(this, this.pm));
            }
        }
        if (this.ns) {
            this.ns = false;
            if (this.nk.ag > 2) {
                this.nq = true;
            }
        }
        if (this.nt) {
            this.nt = false;
            if (this.n6 > 5) {
                this.nq = true;
            }
        }
        if (this.nr) {
            this.nr = false;
            this.nk.ax(this.lx.right, this.lx.bottom, this.lx);
            this.nq = true;
        }
        let h = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        let i = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        let j = new List$1(CalloutAnnotationWrapper.$, 0);
        let k = new List$1(CalloutAnnotationWrapper.$, 0);
        let l = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        for (let m = 0; m < b.count; m++) {
            l.add_1(b._inner[m]);
        }
        for (let n = 0; n < c.count; n++) {
            l.add_1(c._inner[n]);
        }
        let o = this.n1.c;
        while (o != null) {
            let p = o.a;
            if (!l.contains(o.c)) {
                k.add(o.c);
                i.add_1(o.c);
                let q = o.c.b;
                q.propertyChanged = delegateRemove(q.propertyChanged, runOn(this, this.pn));
                this.n1.h(o);
                this.ny.removeItem(o.c);
                this.nk.aw(o.c.c);
            }
            o = p;
        }
        for (let r = 0; r < b.count; r++) {
            if (!this.ny.containsKey(b._inner[r])) {
                this.n1.f(b._inner[r]);
                let s = b._inner[r].b;
                s.propertyChanged = delegateCombine(s.propertyChanged, runOn(this, this.pn));
                this.ny.addItem(b._inner[r], this.n1.d);
                j.add(b._inner[r]);
                h.add_1(b._inner[r]);
                this.nq = true;
            }
        }
        for (let t = 0; t < c.count; t++) {
            if (!this.ny.containsKey(c._inner[t])) {
                this.n1.f(c._inner[t]);
                this.ny.addItem(c._inner[t], this.n1.d);
                let u = c._inner[t].b;
                u.propertyChanged = delegateCombine(u.propertyChanged, runOn(this, this.pn));
                j.add(c._inner[t]);
                h.add_1(c._inner[t]);
                this.nq = true;
            }
        }
        if (this.n3.count > 0) {
            this.nq = true;
            this.n3.clear();
            this.n0.clear();
        }
        o = this.n1.c;
        while (o != null) {
            let v = this.nn(o.c);
            if (v == null) {
                return;
            }
            if (!Base.equalsStatic(v, o.c.c.c)) {
                let w = false;
                if (o.c.c.c == null) {
                    w = true;
                }
                let x = o.c.c;
                x.o = v.b;
                x.p = v.c;
                if (!isNaN_(x.o) && !isNaN_(x.p)) {
                    x.n = v.e;
                    x.m = v.d;
                    if (x.b == null) {
                        this.nk.p(x);
                    }
                    if (w) {
                        this.nk.al(x);
                    }
                    else {
                        this.nk.at(x);
                    }
                }
            }
            o = o.a;
        }
        let y = this.nk.ah();
        let z = this.nk.q();
        if (this.nq && (y != 0 || z)) {
            this.nq = false;
            this.oe = 0x7FFFFFFF;
            if (this.ox != null) {
                let aa = true;
                for (let ab = 0; ab < this.bs.series.count; ab++) {
                    let ac = this.bs.series._inner[ab];
                    if (ac.cj && typeCast(CalloutLayer.$, ac) !== null) {
                        let ad = ac;
                        if (ad.ox == this.ox) {
                            if (!ad.qu.equals1(this.nk.az)) {
                                aa = false;
                                break;
                            }
                        }
                    }
                }
                if (aa) {
                    this.nk.ay();
                }
                else {
                    this.nk.am();
                }
            }
            else {
                this.nk.ay();
            }
        }
        let ae = this.n1.c;
        while (ae != null) {
            let af = ae.c;
            a.m.add1(af);
            a.f.add(af.b.background);
            a.h.add(af.b.outline);
            a.g.add(af.b.leaderBrush);
            a.j.add(af.b.backgroundPadding.c);
            a.l.add(af.b.backgroundPadding.e);
            a.k.add(af.b.backgroundPadding.d);
            a.i.add(af.b.backgroundPadding.b);
            a.n.add(af.b.strokeThickness);
            a.o.add(af.b.textColor);
            a.p.add1(af.b.text);
            a.q.add1(af.b.content);
            let ag = af.c;
            a.t.add(af.c.o - (af.c.g - af.c.l));
            a.u.add(af.c.p - (af.c.h - af.c.k));
            a.r.add(af.c.g - af.c.l);
            a.s.add(af.c.h - af.c.k);
            ae = ae.a;
        }
    }
    pp() {
        if (this.nk != null) {
            let a = this.n1.c;
            while (a != null) {
                let b = a.c.c;
                if (b != null) {
                    this.nk.aw(b);
                }
                a = a.a;
            }
            let c = this.nk;
            c.labelsMoved = delegateRemove(c.labelsMoved, runOn(this, this.pm));
            this.nk = null;
        }
        this.po();
    }
    nl() {
        if (this.bs == null) {
            return null;
        }
        for (let a = 0; a < this.bs.series.count; a++) {
            let b = this.bs.series._inner[a];
            if (b.cj && typeCast(CalloutLayer.$, b) !== null) {
                let c = b;
                if (c != this) {
                    if (c.ox != null && c.ox == this.ox) {
                        if (c.nk != null) {
                            return c.nk;
                        }
                    }
                }
            }
        }
        return null;
    }
    oh() {
        return 20000;
    }
    oi() {
        return 300;
    }
    nm() {
        switch (this.m1) {
            case 0: return 2;
            case 2: return 1;
            case 3: return 2;
            case 1: return 0;
        }
        return 2;
    }
    pm(a) {
        let b = this.nk.ah();
        if (b < this.oe) {
            this.oe = b;
            this.jc(false);
        }
    }
    nn(a) {
        let b = this.m7;
        if (a.b.series != null) {
            b = a.b.series;
        }
        if (b == null) {
            for (let c = 0; c < this.bs.series.count; c++) {
                let d = this.bs.series._inner[c];
                if (!d.cj) {
                    b = d;
                    break;
                }
            }
        }
        if (b == null) {
            return null;
        }
        let e = b.ag();
        let f = b.eh();
        let g = null;
        let h = null;
        for (let i = 0; i < e.length; i++) {
            if (e[i].ce) {
                h = e[i];
            }
            else {
                g = e[i];
            }
        }
        if (g == null || h == null) {
            return null;
        }
        if (!g.cd() || !h.cd()) {
            return null;
        }
        let j = 0;
        if (g.b2 && g.categoryMode != 0) {
            if (b.cr) {
                j = b.getOffsetValue();
            }
            else if (b.cl) {
                j = b.getOffsetValue();
            }
        }
        let k = new ScalerParams(0, this.bs.mq, g.i0, g.b8, g.iv());
        k.b = f;
        let l = new ScalerParams(0, this.bs.mq, h.i0, h.b8, h.iv());
        l.b = f;
        let m = g.dv(this.od(a.b.xValue), k) + j;
        let n = h.dv(this.od(a.b.yValue), l);
        let o = new QuadTreeBoundingBox();
        o.b = m;
        o.c = n;
        o.e = 3;
        o.d = 3;
        o.g = a.b;
        return o;
    }
    od(a) {
        if (typeCast(Date_$type, a) !== null) {
            return a.getTime();
        }
        if (a == null) {
            return 0;
        }
        return a;
    }
    n5() {
        let a = new List$1(CalloutAnnotationWrapper.$, 0);
        for (let b = 0; b < this.n4.count; b++) {
            if (stringIsNullOrEmpty(this.n4._inner[b].b.text)) {
                continue;
            }
            if (this.n4._inner[b].c == null) {
                let c = new LabelCollisionInfo();
                this.n4._inner[b].c = c;
                let d = this.m4.cj(this.oj(this.n4._inner[b]), this.n4._inner[b].b.backgroundPadding);
                c.k = d.height / 2;
                c.l = d.width / 2;
            }
            let e = this.nn(this.n4._inner[b]);
            if (e == null || e.b < this.lx.left || e.b > this.lx.right || e.c < this.lx.top || e.c > this.lx.bottom) {
                continue;
            }
            a.add(this.n4._inner[b]);
        }
        return a;
    }
    oj(a) {
        return a.b.text;
    }
    l5(a) {
        if (!super.l5(a)) {
            return false;
        }
        return true;
    }
    im() {
        super.im();
        if (!this.aq.c && !this.ca()) {
            return;
        }
        if (this.no) {
            this.no = false;
            this.pr();
        }
        if (this.ca()) {
            this.pw(this.l2, false);
        }
        else {
            this.pw(this.l0, false);
        }
    }
    ps() {
        if (!this.np) {
            this.np = true;
            this.jc(true);
        }
    }
    pu(a, b, c) {
        if (a.ch(this.n2, this.nx, this.of)) {
            let d = this.n2;
            for (let e = 0; e < this.n2.count; e++) {
                let f = d._inner[e];
                let g = f.a.item != null ? f.a.item : f.a;
                let h = a;
                let i = new CalloutKey(g, h);
                let j = new CalloutAnnotationWrapper();
                let k = new CalloutAnnotation();
                j.b = k;
                k.key = i;
                let l = false;
                let m = false;
                if (this.np) {
                    this.np = false;
                    m = true;
                }
                if (this.ny.containsKey(j)) {
                    j = this.ny.item(j).c;
                    k = j.b;
                }
                else {
                    if (!m) {
                        l = true;
                    }
                }
                let n = k.xValue;
                let o = k.yValue;
                if (this.od(n) != this.od(f.b)) {
                    k.xValue = f.b;
                }
                if (this.od(o) != this.od(f.c)) {
                    k.yValue = f.c;
                }
                k.series = a;
                if (l && this.calloutLabelUpdating != null) {
                    let p = ((() => {
                        let $ret = new CalloutLabelUpdatingEventArgs();
                        $ret.c = k.xValue;
                        $ret.d = k.yValue;
                        $ret.item = g;
                        return $ret;
                    })());
                    this.calloutLabelUpdating(this, p);
                    if (p.b != null && !Base.equalsStatic(p.b, j.b.text)) {
                        let q = p.b;
                        j.b.text = q != null ? q.toString() : "";
                    }
                }
                else {
                    if (f.d != null) {
                        k.text = f.d;
                    }
                }
                if (k.text == null) {
                    continue;
                }
                if (l) {
                    if (this.calloutContentUpdating != null) {
                        let r = ((() => {
                            let $ret = new CalloutContentUpdatingEventArgs();
                            $ret.c = k.xValue;
                            $ret.d = k.yValue;
                            $ret.item = g;
                            $ret.a = g;
                            return $ret;
                        })());
                        this.calloutContentUpdating(this, r);
                        if (r.a != null && r.a != j.b.content) {
                            j.b.content = r.a;
                        }
                    }
                    else {
                        if (g != null && g != j.b.content) {
                            j.b.content = g;
                        }
                    }
                }
                if (l) {
                    this.py(j);
                }
                if (j.c == null) {
                    let s = new LabelCollisionInfo();
                    j.c = s;
                    let t = this.m4.cj(this.oj(j), j.b.backgroundPadding);
                    s.k = t.height / 2;
                    s.l = t.width / 2;
                }
                let u = this.nn(j);
                if (u == null || u.b < this.lx.left || u.b > this.lx.right || u.c < this.lx.top || u.c > this.lx.bottom) {
                    continue;
                }
                c.add(j);
            }
        }
    }
    bd() {
        return 1;
    }
    ar(a, b) {
        let c = this.nk.d(a, b);
        if (c == null) {
            return null;
        }
        return c.u;
    }
    dh(a, b) {
        if (this.nk == null) {
            return false;
        }
        return this.nk.d(a, b) != null;
    }
    pw(a, b) {
        let c = 0;
        let d = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        for (c = 0; c < a.p.count; c++) {
            let e = a.m._inner[c];
            if (isNaN_(a.t._inner[c]) || isNaN_(a.u._inner[c])) {
                continue;
            }
            let f = this.m4.b6.item(e);
            d.add_1(e);
            if (f.f != a.p._inner[c]) {
                f.f = a.p._inner[c];
                let g = f.s();
            }
            f.c = a.n._inner[c];
            f.k = a.f._inner[c];
            f.n = a.o._inner[c];
            f.m = f.c > 0 ? a.h._inner[c] : this.bi.bn();
            f.l = a.g._inner[c];
            f.v = new Thickness(1, a.j._inner[c], a.l._inner[c], a.k._inner[c], a.i._inner[c]);
            this.m4.cc(f, Math.min(a.r._inner[c], a.r._inner[c] + a.t._inner[c]), Math.min(a.s._inner[c], a.s._inner[c] + a.u._inner[c]));
            this.m4.cd(f, e, a.q._inner[c]);
            f.p = { $type: Point_$type, x: a.t._inner[c], y: a.u._inner[c] };
        }
        let h = new List$1(CalloutAnnotationWrapper.$, 0);
        for (let i of fromEnum(this.m4.b6.c)) {
            if (!d.contains(i)) {
                h.add(i);
            }
        }
        for (let j = 0; j < h.count; j++) {
            this.m4.b6.g(h._inner[j]);
        }
    }
    mn(a, b) {
        super.mn(a, b);
        if (this.ca()) {
            this.pw(this.l2, true);
        }
        else {
            this.pw(this.l0, false);
        }
    }
    c8() {
        return true;
    }
    iy(a, b, c, d) {
        super.iy(a, b, c, d);
        switch (b) {
            case CalloutLayer.$$p[21]:
                this.m8 = null;
                this.jc(true);
                break;
            case CalloutLayer.$$p[20]:
                this.jc(true);
                break;
            case CalloutLayer.$$p[13]:
                this.jc(true);
                break;
            case "SeriesViewer":
                if (c != null) {
                    let e = c;
                    e.seriesAnimating = delegateRemove(e.seriesAnimating, runOn(this, this.pv));
                }
                if (d != null) {
                    let f = d;
                    f.seriesAnimating = delegateCombine(f.seriesAnimating, runOn(this, this.pv));
                }
                if (d == null) {
                    this.pp();
                }
                break;
            case CalloutLayer.$$p[15]:
            case CalloutLayer.$$p[16]:
            case CalloutLayer.$$p[1]:
            case CalloutLayer.$$p[5]:
            case CalloutLayer.$$p[4]:
            case CalloutLayer.$$p[7]:
            case CalloutLayer.$$p[9]:
            case CalloutLayer.$$p[8]:
            case CalloutLayer.$$p[6]:
            case CalloutLayer.$$p[11]:
            case CalloutLayer.$$p[12]:
                this.pq();
                break;
            case CalloutLayer.$$p[19]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nh);
                    this.nh = this.by(this.o9);
                }
                break;
            case "LabelColumn":
                this.pq();
                break;
            case CalloutLayer.$$p[14]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nf);
                    this.nf = this.by(this.o0);
                }
                break;
            case "ContentColumn":
                this.pq();
                break;
            case CalloutLayer.$$p[23]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.ni);
                    this.ni = stringIsNullOrEmpty(this.pg) == false ? this.by(this.pg) : null;
                }
                break;
            case "XColumn":
                this.pq();
                break;
            case CalloutLayer.$$p[24]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nj);
                    this.nj = this.by(this.pj);
                }
                break;
            case "YColumn":
                this.pq();
                break;
            case CalloutLayer.$$p[18]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.ng);
                    this.ng = this.by(this.o6);
                }
                break;
            case "KeyColumn":
                this.pq();
                break;
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.nh);
                    c.deregisterColumn(this.nf);
                    c.deregisterColumn(this.ni);
                    c.deregisterColumn(this.nj);
                    c.deregisterColumn(this.ng);
                    this.nh = null;
                    this.nf = null;
                    this.ni = null;
                    this.nj = null;
                    this.ng = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.nh = this.by(this.o9);
                    this.nf = this.by(this.o0);
                    if (stringIsNullOrEmpty(this.pg) == false) {
                        this.ni = this.by(this.pg);
                    }
                    this.nj = this.by(this.pj);
                    this.ng = this.by(this.o6);
                }
                this.pq();
                break;
        }
    }
    pv(a) {
        if (a.cj) {
            return;
        }
        if ((a == this.m7 || this.m7 == null) && this.nu) {
            this.jc(false);
        }
    }
    pq() {
        if (this.no == false) {
            this.no = true;
            this.jc(false);
        }
    }
    po() {
        this.m4.b6.clear();
        this.n1.g();
        this.ny.clear();
    }
    pr() {
        if (this.nj == null || this.nh == null) {
            let a = this.n1.c;
            while (a != null) {
                this.py(a.c);
                a = a.a;
            }
            return;
        }
        let b = this.nz();
        for (let c = 0; c < this.nj.count; c++) {
            let d;
            if (this.n4.count <= c) {
                let e = new CalloutAnnotation();
                d = new CalloutAnnotationWrapper();
                d.b = e;
                d.b.series = this.m7;
                this.n4.add(d);
            }
            else {
                d = this.n4._inner[c];
            }
            this.px(c, b);
        }
    }
}
CalloutLayer.$t = markType(CalloutLayer, 'CalloutLayer', AnnotationLayer.$);
Type.dep(DependencyProperty, PropertyMetadata, CalloutLayer, 'raisePropertyChanged', ['AutoCalloutLabelPrecision:of:pz', [1, 5], 'CalloutBackground:qo:p0', [Brush.$, null], 'CalloutCollisionMode:m1:p1', [CalloutCollisionMode_$type, enumGetBox(CalloutCollisionMode_$type, 3)], 'CalloutInterpolatedValuePrecision:og:p2', [1, -1], 'CalloutLeaderBrush:qp:p3', [Brush.$, null], 'CalloutOutline:qq:p4', [Brush.$, null], 'CalloutPaddingBottom:n7:p5', [1, NaN], 'CalloutPaddingLeft:n8:p6', [1, NaN], 'CalloutPaddingRight:n9:p7', [1, NaN], 'CalloutPaddingTop:oa:p8', [1, NaN], 'CalloutPositionPadding:ob:p9', [1, 10], 'CalloutStrokeThickness:oc:qa', [1, NaN], 'CalloutTextColor:qr:qb', [Brush.$, null], 'CollisionChannel:ox:qc', [2, null], 'ContentMemberPath:o0:qd', [2, null], 'IsAutoCalloutBehaviorEnabled:nu:qe', [0, false], 'IsCalloutOffsettingEnabled:nv:qf', [0, true], 'IsCustomCalloutStyleEnabled:nw:qg', [0, false], 'KeyMemberPath:o6:qh', [2, null], 'LabelMemberPath:o9:qi', [2, null], 'TargetSeries:m7:qj', [Series.$, null], 'TextStyle:pc:qk', [2, null], 'UseValueForAutoCalloutLabels:nx:ql', [0, true], 'XMemberPath:pg:qm', [2, null], 'YMemberPath:pj:qn', [2, null]]);
/**
 * @hidden
 */
export class CalloutLayerView extends AnnotationLayerView {
    constructor(a) {
        super(a);
        this.b1 = null;
        this.b7 = null;
        this.b6 = null;
        this.b8 = NaN;
        this.b2 = null;
        this.b1 = a;
        this.b7 = new List$1(CalloutView.$, 0);
    }
    ap() {
        super.ap();
        this.b6 = ((() => {
            let $ret = new HashPool$2(CalloutAnnotationWrapper.$, CalloutView.$);
            $ret.create = runOn(this, this.b3);
            $ret.activate = runOn(this, this.b9);
            $ret.disactivate = runOn(this, this.cb);
            $ret.destroy = runOn(this, this.ca);
            return $ret;
        })());
    }
    b3() {
        let a = new CalloutView(this);
        this.b7.add(a);
        return a;
    }
    b9(a) {
        a.w = 0;
    }
    cb(a) {
        a.w = 1;
    }
    ca(a) {
        this.b7.remove(a);
    }
    ci(a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.h(a, 0.1);
    }
    a3(a, b) {
        super.a3(a, b);
        a.ac(this.b5());
        if (a.d && !b) {
            for (let c = 0; c < this.b7.count; c++) {
                let d = this.b7._inner[c];
                if (d.w == 0) {
                    d.h(a);
                }
            }
        }
    }
    b5() {
        if (this.b1.m9 != null) {
            return this.b1.m9;
        }
        return this.e.bs.getFontInfo();
    }
    ai(a) {
        super.ai(a);
        for (let b = 0; b < this.b7.count; b++) {
            let c = this.b7._inner[b];
            if (c.w != 0) {
                continue;
            }
            c.g(this.b1, this.b5(), a);
        }
    }
    ck(a) {
        if (isNaN_(this.b8)) {
            this.b8 = this.e.bs.bn.a7;
        }
        return new Size(1, this.h.f(a.ak), this.b8);
    }
    cj(a, b) {
        if (this.b2 == null) {
            this.b2 = new CalloutView(this);
        }
        this.b2.f = a;
        this.b2.v = b;
        let c = this.b2.s();
        this.b2.f = null;
        return c;
    }
    b4() {
        return new DOMExecutionContext(this.e.bs.bn.i.af);
    }
    cc(a, b, c) {
        a.d = b;
        a.e = c;
    }
    cd(a, b, c) {
        a.i(this.e, b, c);
    }
    ce(a) {
        if (a != null) {
            return this.ci(a.k2);
        }
        return this.e.k2;
    }
    ch() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 255, 255, 255);
            return $ret;
        })());
    }
    cg() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 255, 255, 255);
            return $ret;
        })());
    }
    cf(a) {
        if (a != null) {
            return this.ci(a.k2);
        }
        return this.e.k2;
    }
}
CalloutLayerView.$t = markType(CalloutLayerView, 'CalloutLayerView', AnnotationLayerView.$);
/**
 * @hidden
 */
export class CalloutView extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.w = 0;
        this.j = null;
        this.r = null;
        this.o = { $type: Point_$type, x: 0, y: 0 };
        this.q = null;
        this.u = new Thickness(0, 0);
        this.t = null;
        this.d = 0;
        this.e = 0;
        this.b = null;
        this.q = new Line();
        this.q.ab = false;
        this.q._stroke = ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 0, 0, 0);
            return $ret;
        })());
        this.q.ac = 2;
        this.j = new TextBlock();
        this.r = new Rectangle();
        this.r.ac = 0;
        this.a = a;
        this.w = 0;
    }
    h(a) {
        a.z();
        a.af(this.d, this.e);
        let b = new TranslateTransform();
        b.j = this.t.c;
        b.k = this.t.e;
        this.r.j = b;
        a.r(this.q);
        a.z();
        this.r.width = this.j.m + this.u.c + this.u.d;
        this.r.height = this.j.l + this.u.e + this.u.b;
        a.j(this.r.j);
        a.v(this.r);
        this.j.o = this.u.e;
        this.j.n = this.u.c;
        a.w(this.j);
        a.y();
        a.y();
    }
    get p() {
        return this.o;
    }
    set p(a) {
        if (this.o.x != a.x || this.o.y != a.y) {
            let b = this.s();
            let c = b.height;
            let d = b.width;
            this.o = a;
            let e = CalloutViewHelper.b(this.p, d, c, this.q);
            this.t = e;
        }
    }
    get n() {
        return this.j.am;
    }
    set n(a) {
        this.j.am = a;
    }
    get m() {
        return this.r._stroke;
    }
    set m(a) {
        this.r._stroke = a;
    }
    get l() {
        return this.q._stroke;
    }
    set l(a) {
        this.q._stroke = a;
    }
    get k() {
        return this.r._fill;
    }
    set k(a) {
        this.r._fill = a;
    }
    get c() {
        return this.r.ac;
    }
    set c(a) {
        this.r.ac = a;
    }
    get v() {
        return this.u;
    }
    set v(a) {
        this.u = a;
    }
    get f() {
        return this.j.ak;
    }
    set f(a) {
        if (a == null) {
            this.j.ak = "";
        }
        else {
            this.j.ak = a.toString();
        }
        let b = this.s();
        let c = b.height;
        let d = b.width;
        let e = CalloutViewHelper.b(this.p, d, c, this.q);
        this.t = e;
    }
    s() {
        let a = this.a.ck(this.j);
        this.j.m = a.width;
        this.j.l = a.height;
        return new Size(1, a.width + this.u.c + this.u.d, a.height + this.u.e + this.u.b);
    }
    i(a, b, c) {
        if (this.b == null) {
            this.b = new DataContext();
        }
        this.b.series = a;
        this.b.item = c;
        if (b.c != null) {
            b.c.u = this.b;
        }
    }
    g(a, b, c) {
        a.a2.exportCalloutData(this.d, this.e, this.t.c, this.t.e, c, this.r, this.j, b, this.q, "callout", ["Main", "Callout"]);
    }
}
CalloutView.$t = markType(CalloutView, 'CalloutView');
//# sourceMappingURL=CalloutLayer_combined.js.map